#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  use vars qw(@tt @al $par $date_ymd %sys $date_all $ydat $date_us $date_and_time $isdst $sec $min $hour $mday $mon $year $wday $dow $date $t @t $f @f %data $D %p);

  $D="1"; # Debugmode

  #load lib
  require  "/var/web-gui/data/napp-it/zfsos/_lib/scripts/agents/agent_autolock.lib";

  #get timetables;
  &my_getdate;

 &log_end;
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Timetable'</script>\n";

  print "<b>Timetable $in{'select_tt'}</b><br><br>";
  if ($in{'answered'}) {      # question was answered
     &my_print_tt;
     exit;
  }


  @p=();
  &read_dir("/var/web-gui/_log/autolock/timetables/",'p','\.cfg$');
  @p=sort(@p);
  my $opt="";
  foreach my $p (@p) {
      $p=~s/\.cfg//;
      $opt.="$p,";
  }
  $opt=~s/,$//;

 &ask('begin');
 &ask("select_tt","Select a Timetable",$opt);
 &ask("select_nr","Days to display",'30,60,90,180,360');
 &ask('end');
}

#################
sub my_print_tt {
#################
     my $dow;
     my $today=$date_ymd;
     $D="0";

     #header
     my $table="<b>Day</b>\t<b>Date</b>";
     for (my $n=0;$n<=23;$n++) {
       if ($n<10) { $n="0$n"; $n=~s/^0+/0/; }
       if ($n==0) { $n="00"; }
       $t='&nbsp;' x3;
       $table.="\t$n$t";
     }
     $table.="\t&nbsp\&nbsp\n\n";


     my (@h,$h,$u,$l,@v);
     for (my $n=0;$n<$in{'select_nr'};$n++) {      # next n days

        $p{'unlock_hour'}="";
        $p{'lock_hour'}="";
        $p{'exit'}="0";                            # reset for every day

        &my_a_parse_date($in{'select_tt'});        # do it with timetable
        $dow=&my_getdow($date_ymd);

        @h=();
        $dow=&my_getdow($date_ymd);
        if ($dow eq "mon") { $table.="\n";}

        $dow=uc($dow);
        $h[0]="<b>$dow</b>";
        $h[1]="$date_ymd";

        @v=();
        @v=split(/,/,$p{'unlock_hour'});           # commalist
        foreach my $v (@v) {
            #
            $v=~s/\s+//g;
            $u=$v; $u=~s/:.*//; $u=$u+2;
            $h[$u].="<b style='color:green'>$v</b><br>";
        }

        @v=();
        @v=split(/,/,$p{'lock_hour'});           # commalist
        foreach my $v (@v) {
            #
            $v=~s/\s+//g;
            $u=$v; $u=~s/:.*//; $u=$u+2;
            $h[$u].="<b style='color:red'>$v</b><br>";
        }
        $h[$u]=~s/<br>$//g;
        $h[$u]=~s/<br>/<br>&nbsp;/g;

        $t=join("\t",@h);
        $table.="$t\n";

        $date_ymd=&my_date2add($date_ymd,1);
     }
     $table.="\n";
     print &list2table($table);
     print "<br><br>";
}

###############################################
#end of my script, do not delete the line below
1;