#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  my (@p,@m,$m,$l,$method,$opt,$p,$find,$url,$url2,$url3,$u,$ps,$log,@log);         # declare all your variables as local or you will get errors

  # menue actions
  ###############
  # common lib
  require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/moverlib.pl";

  #exe
  $url= "<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;job==j=\&amp;action==a=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\" onclick=\"return(confirm('execute datamover =m= as a background task??'))\">=t=</a>";

  #log
  $url2="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;job==j=\&amp;action==a=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\">=t=</a>";

  # kill
  $url3="<a style='color:red' href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;job==j=\&amp;action==a=\&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\">=t=</a>";

  ###############################################
  # part 1: do function, if question is answered
  ##############################################

  $log=`find /var/web-gui/_log/datamover/`;
  @log=split(/\n/,$log);
  @log=reverse sort(@log);  # newest first

  # delete logs beside last three
  &my_del($log);

  #execute
  if ($in{'action'} =~/execute|kill/) {     #
       &my_function($log);                  # do it
  }

  ###########
  # Overview
  ###########
       $t="/var/web-gui/_log/datamover";
       @t=();
       &read_dir("$t","t",'.cfg');           # -> @t
       @m=@t;
       $p[0]="<b>Ruleset</b>\t<b>Source ZFS</b>\t<b>Src subfolder</b>\t<b>Destination ZFS</b>\t<b>Dst subfolder</b>\t<b>Method</b>\t<b>Options</b>\t<b>Find options</b>\t<b>Paths</b>\t<b>Use snap</b>\t<b>Src Snap</b>\t<b>Dst snap</b>\t<b>Last Logs</b>\t<b>Mover Status</b>\t\t<b>Action</b>\n";

       @m=sort(@m);

       # debug
       #&print_array(@m);

       %p=();           # clear
       #&print_array(@log);

       foreach my $l (@m) {
                chomp($l);

                $p{'all_mover'}.="$l\t";

                if (!($l=~/\.cfg$/)) { next; }                #no rule
                &my_read($l);

                # m=name ex test.cfg
                $m="$l\t";

                #add source zfs
                $t="mover_$l\_select_src_zfs";
                $m.="$p{$t}\t";

                #add source folder
                $t="mover_$l\_value_src_folder";
                $m.="$p{$t}\t";

                #add destination zfs
                $t="mover_$l\_select_dst_zfs";
                $m.="$p{$t}\t";

                #add destination folder
                $t="mover_$l\_value_dst_folder";
                $m.="$p{$t}\t";

                #add method
                $t="mover_$l\_autoselect_method";
                $method=$p{$t};

                $m.="$p{$t}";

                if ($method eq "move") {
                   # add opt2 for move
                   $t="mover_$l\_select_opt2_move";
                   if ($p{$t}=~/dirmove/) { $m.="-dir"; }
                   if ($p{$t}=~/copy/)    { $m.="-f"; }           # move files + copy folderstructure
                   if ($p{$t}=~/del/)     { $m.="-fdel"; }        # move files + copy folderstructure # del empty src folder
                }
                $m.="\t";

                #add method-options
                $t="mover_$l\_value_opt_$method";
                $m.="$p{$t}\t";
                $opt=$p{$t};

                #all find options
                $find="";

                #find  path
                if ("copy,cpio,move,filesync"=~/$method/) {
                  $t="mover_$l\_value_path";
                  if ($p{$t}=~/^\-i*path/)  {
                    $find.=" $p{$t}";
                  }
                }

                #find  filename
                if ("copy,cpio,move"=~/$method/) {
                  $t="mover_$l\_value_fname";
                  if ($p{$t}=~/^\-i*name/)  {
                    $find.=" $p{$t}";
                  }
                }

                #find depth
                if ("copy,cpio,move"=~/$method/) {
                  $t="mover_$l\_value_depth";
                  if ($p{$t}=~/^\-m..depth/)  {
                    $find.=" $p{$t}";
                  }
                }

                #find file age can be n and -n
                if ("copy,cpio,move"=~/$method/) {
                  $t="mover_$l\_value_age";
                  if ($p{$t}=~/\-mtime/)  {
                    $find.=" $p{$t}";
                  }
                }

                #find size, can be n and -n
                if ("copy,cpio,move"=~/$method/) {
                  $t="mover_$l\_value_size";
                  if ($p{$t}=~/^\-size/)  {
                    $find.=" $p{$t}";
                  }
                }

                #find other
                if ("copy,cpio,move"=~/$method/) {
                  $t="mover_$l\_value_other";
                  if ($p{$t}=~/^\-\w/)  {
                    $find.=" $p{$t}";
                  }
                }

                # add find options
                $find=~s/^ +//; $find=~s/ +/ /g;
                if ($find=~/\w/) {
                  if ((length($find) <12)) {
                     # ok, display
                  } else {
                     $find=~s/\-/__/;                      # keep first find first line
                     $find=~s/\-size \-/-size &ndash;/g;   # neg size
                     $find=~s/\-mtime \-/-mtime &ndash;/g; # neg mtime
                     $find=~s/\-/\&#013;-/g;


                     $find=~s/__/-/;                       # restore first find
                     $t=substr($find,0,20);
                     $find="<a href='#' title=\"  find parameter:\&#013;$find\">$t..</a>" ;
                  }
                  $m.="$find\t";
                } else {
                  $m.="-\t";
                }

                #abs or relative path
                if ("copy,cpio,move,rsync"=~/$method/)             {
                  $t="mover_$l\_select_abspath";
                  $m.="$p{$t}\t";
                } else {
                  $m.="-\t";
                }

                #use snap
                $t="0";
                if ("copy,cpio,rsync"=~/$method/)                  {  $t="1"; }
                if (($method eq "filesync") && (!($opt=~/f/)) )    {  $t="1"; }       # 2way sync
                if ($t) {
                  $t="mover_$l\_select_use_snap";
                  $m.="$p{$t}\t";
                } else {
                  $m.="-\t";
                }

                #src/dst snaps
                if ("copy,cpio,move,rsync"=~/$method/)             {
                  #
                  #add src pre snap
                  $t="mover_$l\_select_src_snap";
                  $m.="$p{$t}\t";

                  #add dest pre snap
                  $t="mover_$l\_select_dst_snap";
                  $m.="$p{$t}\t";
                } else {
                  $m.="-\t-\t";
                }

                #log
                $u="-";
                foreach my $t (@log) {
                   if ($t=~/\/$l\./) {
                       $u=$url2;
                       $u=~s/=a=|=t=/log/g;
                       $u=~s/=j=/$l/g;
                   }
                }
                $m.="$u\t";

                #processes
                $ps=`sudo ps axw | grep datamover.pl | grep -v grep`;  # always to detect stat
                #print "$ps<br>";

                # mover status
                if ($ps=~/$l/s) {
                   $u="running";
                } else {
                   $u="-";
                }
                $m.="$u\t\t";

                # action
                $u=$url;
                if ($ps=~/$l/s) {
                   $u=$url3;
                   $u=~s/=a=|=t=/kill/g;
                } else {
                   $u=~s/=a=|=t=/execute/g;
                }
                $u=~s/=m=/$l/g;
                $u=~s/=j=/$l/g;
                $m.="$u";

                # add line
                push (@p,"$m\n");
       }

       $p{'all_mover'}=~s/\t+$//;

       print "<b>Datamover overview</b><br><br>";

       $t=join("",@p);
       print &list2table($t);

       # header
       print "<script language='javascript'>document.getElementById('hl').innerHTML='Datamover Beta <span style=\"color:red;font-weight:800\">Always run a datamover test prior execution !!</span>'</script>\n";
       &log_end;


       #log
       if ($in{'action'} =~/log/) {      #
         &my_function($log);               # do it
       }

    # debug
    #######################
    if (-f "/tmp/nappit/napp-it_edit_on") {
        $p{'_hashname'}="%p";
        &print_hash(%p);
    }

} #/ my_action



######################
sub my_function {
#######################

   if ($in{'action'} eq "log") {
       my $log=$_[0];
       my @log=split(/\n/,$log);
       @log=reverse sort(@log);  # newest first

       print "<br><br>";
       foreach my $l (@log) {
           if (!($l=~/\/$in{'job'}\..+oklog/)) { next; }             # find newest
           $t=$l; $t=~s/.*\/datamover\///;
           print "<h3>Last OK Log for datamover: $t</h3>";
           print "<pre>".`cat $l`."</pre>";
           last;
       }

       print "<br><br>";
       foreach my $l (@log) {
           if (!($l=~/\/$in{'job'}\..+errlog/)) { next; }             # find newest
           $t=$l; $t=~s/.*\/datamover\///;
           print "<h3>Last Error Log for datamover: $t</h3>";
           print "<pre>".`cat $l`."</pre>";
           last;
       }

       print "<br><br>";
       foreach my $l (@log) {
           if (!($l=~/\/$in{'job'}\..+findlog/)) { next; }             # find newest
           $t=$l; $t=~s/.*\/datamover\///;
           print "<h3>Last Find Log for datamover: $t</h3>";
           print "<pre>".`cat $l`."</pre>";
           last;
       }

      #&print_array(@log);
      return;
   }

   if ($in{'action'} eq "execute") {
        my $t=time();
        `echo "/var/web-gui/data/napp-it/zfsos/_lib/illumos/agents/datamover.pl run_$in{'job'}" > /tmp/$t.sh`;


        if (-f "/tmp/$t.sh") {
          # print "<br><br>request background execution<br>/var/web-gui/data/napp-it/zfsos/_lib/illumos/agents/datamover.pl run_$in{'job'}<br>";
          `sudo chmod 755 /tmp/$t.sh`;
          `sudo /usr/bin/at -s -f /tmp/$t.sh now`;
          `sudo rm /tmp/$t.sh`;
          print "<br>";
          sleep(1);

        }

   }

   if ($in{'action'} eq "kill") {
      $t=`sudo ps axw | grep datamover.pl`;
      @t=split(/\n/,$t);
      foreach my $t (@t) {
         if (!($t=~/_$in{'job'}/))  { next; }

         $t=~s/^ +//;
         $t=~s/ .*//;
         # print "kill $t<br>";
         `sudo kill -9 $t`;
     }
   }


   return;
}

############ del logs beside last three find, err and ok
sub my_del {
###########
  my $log=$_[0];
  my @log=split(/\n/,$log);
  @log=reverse sort(@log);  # newest first

  my ($n,$m,$last);

  #oklog
  $n="0";
  foreach my $l (@log) {
       if (!($l=~/oklog$/)) { next; }

       $m=$l;
       $m=~s/.*datamover\///;         # current mover
       $m=~s/\.cfg.*/.cfg/;

       #print "<br>check $l ($m,$last) ";
       if ($last eq "") { $last=$m; }
       if ($m eq $last) {
            $n++;
       } else {
            $n="0";                   # new/first
            $last=$m;
            next;
       }

       # delete?
       if ($n > 3) {
          #print "<br>### delete $n: $l<br>";
           `sudo rm $l`;
       }
  }

  #errlog
  #print "<hr>";
  $n="0";
  foreach my $l (@log) {
       if (!($l=~/errlog$/)) { next; }

       $m=$l;
       $m=~s/.*datamover\///;         # current mover
       $m=~s/\.cfg.*/.cfg/;

       #print "<br>check $l ($m,$last) ";
       if ($last eq "") { $last=$m; }
       if ($m eq $last) {
            $n++;
       } else {
            $n="0";                   # new/first
            $last=$m;
            next;
       }

       # delete?
       if ($n > 3) {
           #print "<br>### delete $n: $l<br>";
           `sudo rm $l`;
       }
  }

  #findlog
  #print "<hr>";
  $n="0";
  foreach my $l (@log) {
       if (!($l=~/findlog$/)) { next; }

       $m=$l;
       $m=~s/.*datamover\///;         # current mover
       $m=~s/\.cfg.*/.cfg/;

       #print "<br>check $l ($m,$last) ";
       if ($last eq "") { $last=$m; }
       if ($m eq $last) {
            $n++;
       } else {
            $n="0";                   # new/first
            $last=$m;
            next;
       }

       # delete?
       if ($n > 3) {
           #print "<br>### delete $n: $l<br>";
           `sudo rm $l`;
       }
  }

  #&print_array(@log);

}

###############################################
#end of my script, do not delete the line below
1;