use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template
# repli job
#&print_hash(%in);

                        my ($out, $var);  # declare all your variables as local or you will get errors

                         # header
                         print "<script language='javascript'>document.getElementById('hl').innerHTML='Create replication job. You should not auto-snap source/dest filesystems with delzero=yes'</script>\n";

                        # declare later needed vars ($hour,..), used in auto.pl
                        use vars qw($date $hour $min $sec $src_ip);

                        ##################################################
                        # debug mode:
                        # create file /tmp/debug
                        # stop execution via
                        # print('message');  exit;  # message is displayed
                        ##################################################
#&mess("under construction");
                        # menue actions
                        ###############

                        if ($in{'sd'}) {                        #source/dest selected

                            &my_source_target;
                            &log_end;
                            exit;
                        }


                        if ($in{'sd2'}) {                  # source dest menu2
                            &write_job;                    # do it
                        }

                        my @members = glob("$wpath/_log/group/*.txt");      #name only
                        foreach my $m (@members) { $m=~s/.*\///; $m=~s/\.txt$//; }

                        my $members = join(",",@members);
                        #&print_array(@members);

                        if ($in{'select_source'} eq "")      { $in{'select_source'}      = "localhost~127.0.0.1"; }
                        if ($in{'select_destination'} eq "") { $in{'select_destination'} = "localhost~127.0.0.1"; }

                        &ask('begin');
                        &ask('select_source','Select source server',$members,$in{'select_source'});
                        &ask('select_destination','Select destination server',"$members",$in{'select_destination'});
                        &ask('hidden','sd','1');           # source-dest menue
                        &ask('end');

                        if (!($in{'sd'})) { &log_end; exit; }




} #/ my_action

###########################
sub my_source_target {   #  get source and target of a replication
###########################

       # select_source + select_destination selected in menu jobs > create replication
#&print_hash(%in);


       my ($source_fs,$dest_fs,$source_ip,$dest_ip,$source_auth,$dest_auth);
       $source_ip=$in{'select_source'};      $source_ip=~s/.*~//;                  # use ip only
       $dest_ip  =$in{'select_destination'}; $dest_ip  =~s/.*~//;

       $source_auth=$cfg{$source_ip};
       $dest_auth=$cfg{$dest_ip};

#&mess("$source_ip -> $dest_ip<hr>$source_auth , $dest_auth");

       # source_fs
       $source_fs=&socket("zfs list -H -o name auth:=$source_auth",$source_ip,'10');                        # &socket -> cmd auth:=, ip, timeout
#mess($source_fs);
       # dest_fs
       if ($source_ip eq $dest_ip) {
         $dest_fs=$source_fs;
       }  else {
         $dest_fs=&socket("zfs list -H -o name auth:=$dest_auth",$dest_ip,'10');

       }

       $source_fs =~s/\n/,/gs;                            # filesystems, commalist
       $dest_fs   =~s/\n/,/gs;

#&print_var($source_fs);

        &ask('begin','b');
        &ask('hidden','sd2','1');                            # source-dest menue 2
        &ask('hidden','dest_filesystems',$dest_fs);          # to check against new name

        print " <b style='background-color:#dddddd'>Replication from: $in{'select_source'}</b><br>";
        &ask('select_source','Source server',$in{'select_source'});
        &ask('select_src_zfs','Source Pool/ Filesystem',$source_fs,$in{'select_src_zfs'});

        print "<br><br><b style='background-color:#dddddd'>Replication to: $in{'select_destination'}</b><br>";
        &ask('select_dest','Destination server',$in{'select_destination'});
        &ask('select_dest_zfs','Destination Pool/ Filesystem<br>replicated filesystem is created below',$dest_fs,$in{'select_dest_zfs'});

        print "it is suggested to disable recursiv and create multiple jobs per filesystem";
        &ask('select_recursive','enable recursiv','no,yes');

        print "Raw send: useful to send encrypted filesystems";
        &ask('select_raw','zfs raw send','no,yes');

        print "Incremental send: only newest data (-i) or include all intermediary snapshots and clones(-I)";
        &ask('select_send_i','zfs send incremental snapshot option','-i,-I');

        &ask('value_zfs_name','Name of new ZFS (empty=same name as source fs)',$in{'value_zfs_name'});
        ask('value_send_options','other send options',$in{'value_send_options'});
        ask('value_receive_options','other receive options',$in{'value_receive_options'});

        &ask('select_writable','Destination filesystem writable','no,yes');

        # only needed to recreate job
        &ask('value_force_id','Force jobid (to continue a former job)',$in{'value_force_id'});

        &ask('value_esxi','Include ESXi quiesce/memory snaps for ESXi ip <br>If this FS is a NFS/ESXi datastore',$in{'value_esxi'});

        print "<br> <b style='background-color:#dddddd'>Options:</b><br><br>";
        &ask('select_type','Replication type','zfs send via netcat',$in{'select_type'});


        #keep
        print "<br>";
        $t="hours:n, (hourly snap per last n hours)<br>days|months|years:n, (one per last n days|months|years)<br>ex hours:24,days:32,months:12,years:2";
        &ask('value_keep',"Keep target repli snaps (commalist of values or char)<br>$t",$in{'value_keep'});
        &ask('value_hold','Hold target repli snaps for n (days) or n s (snaps)<br>ex 8 = 8days or 8s = 8 snaps, keep empty to hold last two snaps<br><br>Keep and hold are both respected',$in{'value_hold'});

        print "<br><br><b style='background-color:#dddddd'> Timetable</b><br><br>\n";


        &ask('select_month','Month (1..12)','every','every');
        &ask('select_day','Day (sun..sat 1..31)','every,sun,mon,tue,wed,thu,fri,sat,mon-fri,mon-sat,sat-sun,first-sat,first-sun,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31','sun');
        &ask('select_hour','Hour (0..23)','every,every-2,every-2BC,every-3BC,0,3,6,9,12,15,18,21','0');
        &ask('select_min','Minute','every,every-3,every-5,every-10,every-15,every-20,every-30,0,15,30,45,once','0');
        print "<br>\n";
        &ask('select_status','Status','manual,active','manual');

        print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
        print "<div class='info'>Info: 0-3-5 means 0, 3 and 5<br>every-2 (hour) means every two hours<br>every-1BC (hour) means every hour between 7-12 and 13-19 hour (ABCD, each 6 hours from 0..23)";
        print "<br>every month can be every, every-2, every-3,every-4, every-6";
        print "<br>every day can be every, every-2, every-3, every-7, every-14";
        print "<br>every hour can be  every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD - A=0..5, B=6..11, C=12..17, D=18..23";
        print "<br>every minute can be every, every-3, every-5, every-10, every-15, every-20, every-30";
        print "<br>minute=once means: execute job once after each reboot";
        print "<br><br>Your source/target must have different hostnames and should not change IP";
        print "<br>Your target ZFS is read-only after replication. After disabling replication, you can set it to read/write and use it at usual";
        print "</div><br><br>";

        &ask('end');    # create job , start it manually
        print "<br>Replication is speed optimized and unencrypted. <br>If you want to replicate over unsecure networks like Internet, a VPN link (Wireguard) or encrypted raw send is suggested!<br>\n";




#print_array(@source);


}


################################################################################################
sub write_job {    # write job to joblist
################
  # call editpar from menu job create
  if ($in{'action'} eq 'editpar') { return; }

  # select_source/dest (membername~ip)
  # select_source_zfs/dest_zfs (or 'zfs not installed')
  # select_min/hour/day/month/status (manual)
  # select_send_i/raw/recursive
  # value_zfs_name/force_id/keep/hold/receive_options/send_options

  #parse
  $in{'select_source'}=~s/.*~//;             # use ip only
  $in{'select_dest'}=~s/.*~//;

  #if ($in{'select_source_fs'} eq "zfs not installed") { &mess("ZFS not installed on source"); }
  #if ($in{'select_dest_fs'}   eq "zfs not installed") { &mess("ZFS not installed on destination"); }

     #

  my ($var,$id,$port,$host,$hostip,$source,$destination,$send_i,$transport,$port,$recursiv,$send_dedup,$send_opt,$pv_limit,$dest_sharename,$dest_shareguest,$dest_shareabe,$rec_opt,$daisy,$esxi);

  # 1. parse destination
   $in{'value_zfs_name'}=~s/\s//g;
    if ($in{'value_zfs_name'} eq '') {
        $in{'value_zfs_name'} = $in{'select_src_zfs'};
        $in{'value_zfs_name'}=~s/^.*\///;
    } else {
        $in{'value_zfs_name'}=~s/[^a-zA-Z0-9_\.\-:]//g;            # allowed in name
        if ($in{'value_zfs_name'} eq '') { &mess('ERROR: name of replicated dataset; Please enter a valid name for new dataset'); }
    }

    $destination="$in{'select_dest_zfs'}/$in{'value_zfs_name'}";
    if ($in{'dest_filesystems'}=~/\b$destination\b/)     { &mess("Filesystem $destination exists, please select another name"); }

#    &print_hash(%in);

  # 2. id of this job ########
    ############################
    if ($in{'value_force_id'} > 0) {
       $id=$in{'value_force_id'};
    } else {
       $id = time();
    }

    # port from id > 50000
    # $port=((($id / 60) % 55500) + 10000);
    $port=substr($id,-4,4);
    my $sum="";
    my @sum=split(//,$id);
    foreach my $char (@sum) { $sum=$sum+ord($char); }
    $port=$sum+50000+$port;


  # 3. parse input, needed source_ip,dest_ip,source_zfs,destination_zfs,transport,port,recursiv,send_options,receive_options
  ################



    $transport="nc";  # default
    if ($in{'select_type'} =~/mbuffer/)  { $transport="mbuffer"; }
    if ($in{'select_type'} =~/ssh/)      { $transport="ssh"; }             # optional later

    if ($in{'checkbox_recursive'} ne "") { $recursiv="yes"; }              # rec
    if ($in{'checkbox_dedup'} ne "")     { $send_dedup="yes"; }            # dedup

    $dest_sharename=$in{'value_zfs_share'};                                # smb share destination as
    if ($in{'checkbox_guest'} ne "")     { $dest_shareguest="yes"; }       # guestok
    if ($in{'checkbox_abe'} ne "")       { $dest_shareabe="yes"; }         # share with ABE

    $send_opt=$in{'value_zfs_sendopt'};                                    # send options like '--raw' or '-w compress'
    $rec_opt=$in{'value_zfs_recopt'};                                      # receive options like '-u' (do not mount)

    $pv_limit=$in{'value_pv_limit'};                                       # limit throughput via pv ex '-L 300k'

    $esxi=$in{'value_esxi'};                                               # esxi server with nfs on this filesystem
    $esxi=~s/ +//g;

    # destination fs either source fs name or zfs_name
    $t=$in{'select_src_zfs'};
    $t=~s/.*\///;           # tank/data -> data

    #
    $in{'value_zfs_name'}=~s/ +//g;
    if ($in{'value_zfs_name'} ne "") {
       $t=$in{'value_zfs_name'};
    }
    # full path of destination
    $in{'select_dest_zfs'}.="/$t";

    #&print_hash(%in);

    # 4.  # select_source/dest (membername~ip)
    # select_source_zfs/dest_zfs (or 'zfs not installed')
    # select_min/hour/day/month/status (manual)
    # select_send_i/raw/recursive
    # value_zfs_name/force_id/keep/hold/receive_options/send_options/esxi
    ###################################

    $var ="job=replicate\n";
    $var.="source_ip=$in{'select_source'}\n";
    $var.="destination_ip=$in{'select_dest'}\n";
    $var.="source_zfs=$in{'select_src_zfs'}\n";
    $var.="destination_zfs=$in{'select_dest_zfs'}\n";
    $var.="zfs_name=$in{'value_zfs_name'}\n";
    $var.="writable=$in{'writable'}\n";
    $var.="transport=$transport\n";
    $var.="port=$port\n";
    $var.="recursiv=$in{'select_recursive'}\n";
    $var.="send_raw=$in{'select_raw'}\n";
    $var.="esxi_ip=$in{'value_esxi'}\n";                               # ip, this is a filesystem -> ESXi NFS
    $var.="send_i=$in{'select_send_i'}\n";                             # -i or -I
    $var.="send_options=$in{'value_send_options'}\n";
    $var.="rec_options=$in{'value_receive_options'}\n";
    $var.="pv_limit=$in{'value_pv_limit'}\n";                          # opt

    $var.="keep=$in{'value_keep'}\n";                                  # keep snaps

    if ($in{'value_hold'}=~/s/) {
         $in{'value_hold'}=~s/\D//g;
         $in{'value_hold'}.="s";
    } else {
         $in{'value_hold'}=~s/\D//g
    }
    $var.="hold=$in{'value_hold'}\n";                     # hold snaps in days or with s for snaps

  # 5. create job.par with variables inside
  ###########################################

    $var.="month=$in{'select_month'}\n";
    $var.="day=$in{'select_day'}\n";
    $var.="hour=$in{'select_hour'}\n";
    $var.="min=$in{'select_min'}\n";
    $var.="status=$in{'select_status'}\n";
    $var.="last=new\n";


 #debug
 #&mess("<pre>id=$id\n$var");

    my $f="$wpath/_log/jobs/$id.par";     # jobfile
    open (F,">$f");
          print F "$var";
    close (F);


  # reload page
    $in{'l3'}="";
    &reload;
    exit;
} #/ write job
###############









###############################################
#end of my script, do not delete the line below
1;