###############
sub my_action {
###############
     # 25.nov 2018

    #override with private functions?
    ##################################
        eval { &mylib_menue_snaps_delete };                   # create this function in a private mylib.pl to replace this action


    my ($var1, $var2, $ant);
    # header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='Mass destroy of snapshots on $in{'member'}'</script>\n";

    #del selected
    $in{'sel_snaps'}=~s/\.\+$//;
    if (($in{'answered'}) && ($in{'sel_snaps'} ne "")) { &del_myselected; }                     # del selected snaps
    if (($in{'answered'}) && ($in{'submit_ok'} eq "delete selected")) { $in{'answered'}="";  }  # none selected


    #form answered
        if ($in{'answered'}) { &del_mysnaps; }                                  # del filtered snaps


    #create form
        #############
    &load_lib('zfslib.pl');

    #ask basic infos like time
    ##########################
    print "$txt{'del_warning'}";
    &ask('begin');

    &ask('value_name',$txt{'form_name'});
    &ask('value_older',$txt{'form_older'},'30','w60');
    &ask('value_newer',$txt{'form_newer'},'','w60');
    &ask('value_from',"$txt{'form_from'} 1..n",'','w60');
    &ask('value_to',"$txt{'form_to'} 1..n",'','w60');
    &ask('checkbox_used',$txt{'form_size'},'delete only unused','d');
    &ask('checkbox_repli',$txt{'form_repli'},'delete replication snaps','d');
    &ask('checkbox_sim',$txt{'form_simulate'},'simulate','simulate');
    if ($cfg{'ver'}=~/\w/) { print "<br>Features for a valid Pro/ Dev edition";
    &ask('select_keep_interval','Keep at least one snap per filesystem and','-,day,week,month');
    &ask('checkbox_background','Destroy as a background task','background','b');
    } else { print "keep one snap per filesystem per day/week/month or background snap delete: <br>available on valid Pro or Dev editions<br><br>"; }


    &ask('end');
###############
    print "\n<br><br>";



 #list datasnaps
 ###############
    &zfslib_list_datasnaps('d');


} #/ my_action
##############


#############
sub del_myselected {
############
#debug
  # &print_hash(%in);

    my @snaps=split(/\.\+/,$in{'sel_snaps'});
    foreach my $s (@snaps) {
            if (!($s=~/\@/)) { next; }
            $r=&exe("zfs destroy \"$s\"");
            print "snap $s deleted<br>";
    }
    sleep(1);
    if (-f "/tmp/acc-snap.log") {  &exe("rm /tmp/acc-snap.log"); }
    &reload;
}

##############  mass delete
sub del_mysnaps {
##############
my ($ant,$name,$id,$days,$err,$l,@s,$del,@w,$r,$n,$int,%interval,$fs);
$err="";

#&print_hash(%in);


# background del
if ($in{'checkbox_background'}=~/back/) {
     &mess("under development");
     if (-f "/tmp/bsnapdel.sh") {
          &exe("rm /tmp/bsnapdel.sh");
     }
}
if (-f "/tmp/bsnapdel.log") {
          &exe("rm /tmp/bsnapdel.log");
}

#parse
    $in{'value_name'}=~s/[^a-zA-Z0-9\-\+\_\.\*\?\/]//g;

    $in{'value_older'}=~s/[^0-9]//g;
    $in{'value_newer'}=~s/[^0-9]//g;

#input?
    if ($in{'value_name'} eq "") {  $err.="Name (text or Regular expession ex. dat.*)"; }


# * = regEx .*
    if (($in{'value_name'} eq "*") || ($in{'value_name'} eq "."))  { $in{'value_name'}=".*"; }


# name daten/xx is valid
    $in{'value_name'}=~s/\//\\\//g;

# name dayly@123456 is valid
    $in{'value_name'}=~s/\@/\\\@/g;

$err=~s/^, //;
if ($err ne "") { &mess("Please fill out: $err"); }

#get datasnaps
print "please wait...<br>\n";
    $l=&zfslib_list_datasnaps('f');        #full commalist of snaps: name \t id "blanks" date


@s=split(/,/,$l);
my $count="0";

foreach $t (@s) {                                      # fs tab snapname tab date
    # b3/r_hfg/am    b3/r_hfg/am@1443780391_repli_zfs-kh5101_rz-backup3_nr_423    Dec 31 21:05 2016     3.23K  -  1.76T
    $del="1";

    $t=~s/Mon |Tue |Wed |Thu |Fri |Sat |Sun //g;       # no dow
    $t=~s/\d+:\d+ +//;                                 # remove hour

    $t=~s/ +/\t/g;                                     # tab between zfs name and snapname, mon, day, year, ....

    @w=split(/\t/,$t);

    # [0] -> 'b3/r_hfg/am'
    # [1] -> 'b3/r_hfg/am@1443780391_repli_zfs-kh5101_rz-backup3_nr_423'
    # [2] -> 'Dec'
    # [3] -> '31'
    # [4] -> '2016'
    # [5] -> '3.23K'
    # ..

    $s=$w[1];                # selected snap
    $fs=$s; $fs=~s/\@.*//;   # filesystem

    # check used=0
    if ($in{'checkbox_used'} =~/delete/) {

        # only autosnap generated snaps, no repli snaps
        # if (!($w[1]=~/_\d+\.\d+\.\d+/))    { next; }          # allow all snapnames
        if ($w[1]=~/_repli/)               { next; }

        # only used=0
        $r=&exe("zfs get -H -o value used $w[1]"); chomp ($r);
        if ($r ne "0") {
           next;
        }
    }


    if ($in{'value_name'} ne ".*") {
       if (!($w[1]=~/$in{'value_name'}/))  { next; }
    }


    #check old
    # sub date2diff {        # Datumsdifferenz in Tagen;
    # parameter: datum ("tt.mm.jjjj","tt.mm.jjjj")

    #month in w[2], day in w[3], year in w[4]
    $w[2]=~s/Jan/01/; $w[2]=~s/Feb/02/; $w[2]=~s/Mar/03/; $w[2]=~s/Apr/04/; $w[2]=~s/May/05/; $w[2]=~s/Jun/06/;
    $w[2]=~s/Jul/07/; $w[2]=~s/Aug/08/; $w[2]=~s/Sep/09/; $w[2]=~s/Oct/10/; $w[2]=~s/Nov/11/; $w[2]=~s/Dec/12/;
    $days=&date2diff("$w[3].$w[2].$w[4]","$sys{'mday'}.$sys{'mon'}.$sys{'year'}");

    # debug
    #&mess($t);
    # &print_array(@w);

    #keep one per interval
    if ($in{'select_keep_interval'}=~/\w/) {               # keep at least one per day/week/monthy
         # keep one per day
         if ($in{'select_keep_interval'}=~/day/) {
            $int=&date2dop("$w[3].$w[2].$w[4]");           # day of period
            $int.="_$fs";

            if ($interval{$int} ne "1") {
                 if ($in{'checkbox_sim'}=~/sim/) { print " --would keep first snap of day $int - $s<br>";    }
                 $interval{$int} ="1";                     # parameter: date2dop (datum),  ("tt.mm.jjjj")
                 next;                                     # keep it
            }
         }
         # keep one per week
         if ($in{'select_keep_interval'}=~/week/) {
            $int=&date2dop("$w[3].$w[2].$w[4]");           # day of period
            if (!($int >0)) { $int='1'; }
            $int=int($int/7);                              # per week
            $int.="_$fs";

            if ($interval{$int} ne "1") {
                 if ($in{'checkbox_sim'}=~/sim/) { print " --would keep first snap of week $int - $s<br>";  }
                 $interval{$int} ="1";                     # parameter: date2dop (datum),  ("tt.mm.jjjj")
                 next;                                     # keep it
            }
         }

         # keep one per month
         if ($in{'select_keep_interval'}=~/month/) {
            $int="$w[2].$w[4]";                            # mm.jjjj
            $int.="_$fs";

            # per month
            if ($interval{$int} ne "1") {
                 if ($in{'checkbox_sim'}=~/sim/) { print " --would keep first snap of month $int - $s<br>";  }
                 $interval{$int} ="1";                     # parameter: date2dop (datum),  ("tt.mm.jjjj")
                 next;                                     # keep it
            }
         }

    }


    if ($in{'value_older'} ne "") {
         if ($days <= $in{'value_older'}) { next; }        # older than
    }


    if ($in{'value_newer'} ne "") {
      if ($days >= $in{'value_newer'}) { next; }           #newer than
    }

    #skip repli
    if (!($in{'checkbox_repli'} =~/del/)) {
       if ($s=~/repli_/) { next; }
    }

    # repli nr:
    if ($s=~/_nr_/) {
       $n=$s; $n=~s/.*_nr_//;
       if ($n > 0) {
           #
           #only if larger than
           if ($in{'value_from'} >= 1) {
                if ($n <= $in{'value_from'}) { next; }
           }

           #only if less than
           if ($in{'value_to'} > 1) {
                if ($n >= $in{'value_to'})  { next; }
           }
        }
    }


    #destroy snap
      if ($in{'checkbox_sim'}=~/sim/) {
         print "would delete $s<br>\n";
         $count++;
      } else {
         if ($in{'checkbox_background'}=~/back/) {
             open (PF, ">>/tmp/bsnapdel.sh");          # list
                       flock(PF, LOCK_EX);
                       print PF "echo \'zfs destroy \"$s\"\' >> /tmp/bsnapdel.log\n";
                       print PF "/usr/sbin/zfs destroy \'$s\' >> /tmp/bsnapdel.log 2>&1\n";
             close (PF);
             print "request background zfs destroy $s $r<br>\n";
         } else {
             $r=&exe("zfs destroy $s");
             print "zfs destroy $s $r<br>\n";
         }

         $count++;
      }

}


&log_end;
print "<hr>$count snapshots counted<br><br><br>";
if ($in{'checkbox_sim'}=~/sim/) {  print "<hr>$count snapshots would be deleted<br>go back and unselect simulation to delete them<br><br><br>"; exit; }

#background destroy
if ($in{'checkbox_background'}=~/back/) {
   if (-f "/tmp/bsnapdel.sh") {
      print "request background destroy<br>";
     `sudo chmod 755 /tmp/bsnapdel.sh`;
     `sudo /usr/bin/at -f /tmp/bsnapdel.sh now`;
#     `sudo /usr/bin/at -s -f /tmp/bsnapdel.sh now > /dev/null 2>&1`;      # opt without mess
   }
}


if (-f '/tmp/nappit/zfs_last.zfs') { &exe("rm /tmp/nappit/*.zfs"); }
sleep(2);
#debug
#exit;

&reload;
#&mess($l);


}




###############################################
#end of my script, do not delete the line below
1;
