sub my_action {
###############
# Realtime Monitor
# (c) 2014 Gnther Alka

my ($r, $txt,$t );

  # header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Realtime monitor overview (PRO monitor/complete license)'</script>\n";
  if (!($cfg{'ver'}=~/c|m/)) { print "requires monitor extension!"; &log_end; exit;   }

  ##############  stat ###################

   print <<EoF;

<div id='wsdata' style='position:absolute; top: 155px; left:5px; z-index:1100; color:#666666; font-size:10px'>connect to monitor-server..</div>
<table style='width:1200px'>

<tr><td>
     <!-- iostat r/w -->
     <canvas id="cvs1" width="600" height="250">[No canvas support]</canvas>

</td><td>
     <!-- graph-height -->
     <canvas id="cvs2" width="600" height="250">[No canvas support]</canvas>
</td></tr>

<tr><td>
relative/avrg values vs worst disk are not absolute values. Compare both only for weak disks.
     <!-- arcstat -->
     <canvas id="cvs3" width="600" height="250">[No canvas support]</canvas>

</td><td>
     <!-- netstat -->
     <canvas id="cvs4" width="600" height="250">[No canvas support]</canvas>
</td></tr>

<tr><td>
     <!-- cpu -->
     <canvas id="cvs5" width="600" height="250">[No canvas support]</canvas>

</td><td>
     <!-- service -->
     <canvas id="cvs6" width="600" height="250">[No canvas support]</canvas>
</td></tr>

</table>


<!-- iostat script -->
<script type="text/javascript">

    // iostat
    rgraph_iostat=function(data) {

           // reset or old values keep visible
           var canvas = document.getElementById('cvs1');
           RGraph.Reset(canvas);

           canvas = document.getElementById('cvs2');
           RGraph.Reset(canvas);

           // prepare data
           var adata=data.split(";");            // iostat; time; x-unit; devicenumbers; labels1; key1 ;diskdata1(io); key2; diskdata2(busy/wait); cpubusy ; height

           \$("#cvs1").height(250);              // set height ??
           \$("#cvs1").width(600);               // set height ??

           var alabels1=adata[2].split(",");     // labels1 (y-values=sd1,sd2)
           var alabels2=adata[6].split(",");     // labels1 (y-values=sd1,sd2)
           var n=alabels1.length;                 // number of devices

           var akeys1=adata[3].split(",");       // keys1  (x values=read,write)
           var akeys2=adata[7].split(",");       // keys2

           var data1=adata[4].split(":");         // data1
           var data2=adata[8].split(":");         // data2

           var adata1=new Array(n);              // array of data1 (array of arrays)
           var adata2=new Array(n);              // array of data2 diskdatas (array of arrays)

           var busy=adata[9];                    // busy
           var avbusy=adata[10];                 // busy 10s

           // diskdata: build array of arrays
           for (var i = 0; i < n; i++ ) {
                adata1[i] = data1[i].split(",");
           }

           //alert(alabels);

           // disk_avrg_data: build array of arrays
           for (var i = 0; i < n; i++ ) {
                adata2[i] = data2[i].split(",");
           }

           // debug: read/write/ar/aw
           // alabels=['1','2','3','4','5']
           // alert(alabels);
           // var hbar1 = new RGraph.HBar('cvs1', [[800,600,400,300], [400,800,300,500],[400,900,900,700],[600,500,300,400],[300,700,800,800]])         // test

           var hbar1 = new RGraph.HBar('cvs1',adata1)
               .Set('title', 'iostat: read/write per/s')
               .Set('title.size', '8')
               .Set('title.vpos', 0.5)

               .Set('gutter.top', 45)

               .Set('grouping', 'grouped')
               .Set('vmargin', 5)             // affects bar-thickness
               .Set('xmax', adata[1])          // x-range 1000, 2000,..

               .Set('labels', alabels1)
               .Set('key', akeys1 )
                 //.Set('labels', ['sd1','sd2'])
                 //.Set('key', ['read','write'])



               .Set('key.position', 'gutter')
               .Set('key.position.gutter.boxed', false)
               .Set('key.colors', ['green','#c0ebc0','red','#fe9e9e'])
               .Set('colors', ['Gradient(#7ae472:green)',
                               'Gradient(#c0ebc0:#c0ebc0)',
                               'Gradient(#fa8973:red)',
                               'Gradient(#fbe3de:#ecbc91)'
                               ])
                .Draw(hbar1);



           // wait, await, w%, b%
           var hbar2 = new RGraph.HBar('cvs2', adata2 )
               .Set('title', 'iostat: wait/ w%/ b%  //CPU busy/10s_avrg = ' +busy +'%/ ' +avbusy +'%')
               .Set('title.size', '8')
               .Set('title.vpos', 0.5)
               .Set('gutter.top', 45)

               .Set('grouping', 'grouped')
               //.Set('shadow', true)
               .Set('vmargin', 5)
               .Set('xmax', 100)        // x-range max
               .Set('xmin', 0)          // x-range min 0
               .Set('labels', alabels2)
               .Set('key', akeys2 )
               .Set('key.position', 'gutter')

               .Set('key.position.gutter.boxed', false)
               .Set('key.colors', ['red','#fcb39d','blue','green'])
               .Set('colors', ['Gradient(#fa8973:red)',
                               'Gradient(#fcb39d:#fcb39d)',
                               'Gradient(#bbc8fe:blue)',
                               'Gradient(#7ae472:green)'
                               ])
                .Draw(hbar2);
    }

    //3. arcstat only
    rgraph_arczilstat=function(data) {

           // reset or old values keep visible
           var canvas = document.getElementById('cvs3');
           RGraph.Reset(canvas);

           // prepare data
           var adata=data.split(",");            // l,l2,zil,zil2

           var alabels=['ARC','L2ARC','ARC-avrg','L2ARC-avrg'];    // labels (y-values=e1000,vmxnet)
           var akeys=['ARC','L2ARC', 'avrg%','l2avrg%'];           // keys1  (x values=read,write)

           var darray=new Array(4);                                 // array of diskdatas (array of arrays)

           // darray: build array of data
           var n=4;
           for (var i = 0; i < n; i++ ) {
                darray[i] = adata[i].split(",");
           }


           //var hbar3 = new RGraph.HBar('cvs3', [10,20,30,40])         // test
           var hbar3 = new RGraph.HBar('cvs3', darray )
               .Set('title', 'arcstat hitrate in %')
               .Set('title.size', '8')
               .Set('title.vpos', 0.5)
               .Set('gutter.top', 45)

               .Set('grouping', 'grouped')
               .Set('vmargin', 20)        // line-thickness
               .Set('xmax', 100)          // x-range 1000, 2000,..

               .Set('labels', alabels)       // ex e1000, vmxnet
               .Set('key', akeys )           // read,write

               .Set('key.position', 'gutter')
               .Set('key.position.gutter.boxed', false)
               .Set('key.colors', ['green','green'])
               .Set('colors', ['Gradient(#7ae472:green)',
                               'Gradient(#7ae472:green)',
                               'Gradient(#c0ebc0:#c0ebc0)',
                               'Gradient(#c0ebc0:#c0ebc0)'
                               ])
                .Draw(hbar3);
    }


    // nicstat   links;data;x;text
    rgraph_netstat=function(data) {

           // reset or old values keep visible
           var canvas = document.getElementById('cvs4');
           RGraph.Reset(canvas);

           // prepare data
           var adata=data.split(";");            // links;data;xmax;text

           var alabels=adata[0].split(",");      // labels (y-values=e1000,vmxnet)
           var akeys=['write','read'];            // keys1  (x values=read,write)

           var ddata=adata[1].split(":");        // data
           var darray=new Array(n);              // array of nicdatas (array of arrays)

           var n=alabels.length;

           // diskdata: build array of arrays
           for (var i = 0; i < n; i++ ) {
                darray[i] = ddata[i].split(",");
           }

           //read/write/ar/aw
          //  var hbar = new RGraph.HBar('cvs4', [ [8,6], [4,8] ])         // test

          var hbar4 = new RGraph.HBar('cvs4', darray )
               .Set('title', 'nicstat Mbps')
               .Set('title.size', '9')
               .Set('title.vpos', 0.5)
               .Set('gutter.top', 45)

               .Set('grouping', 'grouped')
               .Set('vmargin', 20)             // line-thickness
               .Set('xmax', adata[2])         // x-range 1000, 2000,..

               .Set('labels', alabels)       // e1000, vmxnet
               .Set('key', akeys )           // read,write

               .Set('key.position', 'gutter')
               .Set('key.position.gutter.boxed', false)
               .Set('key.colors', ['green','red'])
               .Set('colors', ['Gradient(#7ae472:green)',
                               'Gradient(#fa8973:red)'
                               ])
                .Draw(hbar4);
    }


    // 5. prstat: cpu and processes
    rgraph_cpustat=function(data) {

           // reset or old values keep visible
           var canvas = document.getElementById('cvs5');
           RGraph.Reset(canvas);

           // prepare data
           var adata=data.split(";");            // labels;data,text  ex perl,ssh;0.1,0.2;load in %
           //alert(adata);

           \$("#cvs5").height(250);              // set height ??
           \$("#cvs5").width(600);               // set height ??

           var alabels=adata[0].split(",");      // labels (y-values=iostat,perl)
           var pdata=adata[1].split(",");        // psdata
           var pkey=adata[2].split(",");         // key:  load in %

           //alert(pkey);
           //pdata=[1.6,1.5,0.9,0.4,0.3,0.6,0.6,0.5,1,2];

           //var hbar5 = new RGraph.HBar('cvs5', [8.6,0.6,4,3,7,5,3,9,7,4])         // test
           var hbar5 = new RGraph.HBar('cvs5', [ pdata ])
               .Set('title', 'prstat')
               .Set('title.size', '9')
               .Set('title.vpos', 0.5)
               .Set('gutter.top', 45)

               .Set('grouping', 'grouped')
               .Set('vmargin', 5)              // line-thickness
               .Set('xmax', 100)               // x-range 1000, 2000,..

               .Set('labels', alabels)

               //.Set('labels', ['sd1','sd2'])

               .Set('key', pkey )
                // .Set('key', ['Monday','Tuesday','Wednesday','Thursday'])



               .Set('key.position', 'gutter')
               .Set('key.position.gutter.boxed', false)
               .Set('key.colors', ['#fa8973'])
               .Set('colors', ['Gradient(#fbe3de:#ecbc91)',
                               'Gradient(#fbe3de:#ecbc91)',
                               'Gradient(#fbe3de:#ecbc91)',
                               'Gradient(#fbe3de:#ecbc91)',
                               'Gradient(#fbe3de:#ecbc91)',
                               'Gradient(#fbe3de:#ecbc91)',
                               'Gradient(#fbe3de:#ecbc91)',
                               'Gradient(#ecbc91:#fa8973)',
                               'Gradient(#ecbc91:#fa8973)',
                               'Gradient(#ecbc91:#fa8973)'
                               ])
                .Draw(hbar5);

    }


    // 6. fsstat
    rgraph_servicestat=function(data) {

           // reset or old values keep visible
           var canvas = document.getElementById('cvs6');
           RGraph.Reset(canvas);

           //debug
           //data="ufs,nfs,zfs,lofs,tmpfs,mntfs,nfs3,nfs4,autofs;0,0,0,0:0,0,0,0:16.9,789,820,133:0,0,0,0:125,4,4,1:0,0,0,0:0,0,0,0:0,0,0,0:0,0,0,0;900;lockup,rddir,read,write";

           // prepare data
           var adata=data.split(";");           // label; data; max; key

           var alabels=adata[0].split(",");      // labels like ufs, zfs
           var ddata=adata[1].split(":");        // fsdata
           var max=adata[2];

           // number of services/fs
           var akeys=adata[3].split(",");        // keys  (x values=read,write)

           var n=alabels.length;
           var darray=new Array(n);              // array of diskdatas (array of arrays)


           // servicedatadata: build array of arrays
           for (var i = 0; i < n; i++ ) {
                darray[i] = ddata[i].split(",");
           }
           //alert(ddata[6])

           //read/write/ar/aw
            // var hbar6 = new RGraph.HBar('cvs6', [[8,6,4,3], [4,8,3,5],[4,9,9,7],[6,5,3,4],[3,7,8,8]])         // test

           var hbar6 = new RGraph.HBar('cvs6', darray)
               .Set('title', 'fsstat: operations per filesystem or service per s')
               .Set('title.size', '9')
               .Set('title.vpos', 0.5)
               .Set('gutter.top', 45)

               .Set('grouping', 'grouped')
               .Set('vmargin', 3)               // line-thickness
               .Set('xmax', max)                // x-range 1000, 2000,..

               .Set('labels', alabels)
               //.Set('labels', ['zfs','nfs','nfs','nfs','nfs','nfs','nfs','nfs','nfs'])

               .Set('key', akeys)
               //.Set('key', ['read','write','..','..'])

               .Set('key.position', 'gutter')
               .Set('key.position.gutter.boxed', false)
               .Set('key.colors', ['green','#c0ebc0','blue','#fe9e9e'])
               .Set('colors', ['Gradient(#7ae472:green)',
                               'Gradient(#c0ebc0:#c0ebc0)',
                               'Gradient(#bbc8fe:blue)',
                               'Gradient(#fbe3de:#ecbc91)'
                               ])
               .Draw(hbar6);

    }


</script>



EoF



} #/ my_action


###############################################
#end of my script, do not delete the line below
1;
