sub my_action {
###############
# Longterm Monitor
# (c) 2014-2017 Gnther Alka
# 21.7.2017

my ($r,$txt,$t,@l,@p,$x,@h,$hour,$d,@d,@l,$l,@w,$w,$reload);

# read all log values
$l=`ls /var/web-gui/_log/monitor/ | grep .log`;
@l=split(/\n/,$l);
@l=sort(@l);

# &print_array(@l);
# no hour given: set day=today
if ($in{'prop'} eq "") {                  # no hour
   if (-f "/var/web-gui/_log/monitor/iostat.$sys{'mday'}.$sys{'hour'}.log")    {    # iostat.day.hour.log
      $in{'prop'}=$sys{'hour'};                                                     # current day.hour
      $in{'prop2'}=$sys{'mday'};
   } else {
      @w=();
      @w=split(/\./,$l);                  # iostat.day.hour.log
      $in{'prop'} =$w[2];                 # first hour value
      $in{'prop2'}=$w[1];                 # first day value
   }
   $reload="1";                          # read data with dev
}

#&print_hash(%in);
#&mess($reload);

# all possible hours for selected day
@h=(); @d=();
$d=""; $h="";
foreach $l (@l) {
   @w=();
   @w=split(/\./,$l);                     # iostat.day.hour.log
   if ($w[3] ne 'log') { next; }          # wrong data

   if (!($d=~/,$w[1],/)) {
     push(@d,$w[1]);                      # all days but only once
     $d.=",$w[1],";
   }
   if ($w[1] ne $in{'prop2'}) { next; }   # only hours of selected day
   push(@h,$w[2]);
}

# &print_array(@d);

if (!($cfg{'ver'}=~/c|m/)) { print "requires Pro monitor or complete!"; &log_end; exit;   }
if (!(@h > 0)) { &mess("no longterm data available, enable monitoring 'Mon' in toplevel menu"); }

if (-f "/var/web-gui/_log/monitor/iostat.$in{'prop2'}.$in{'prop'}.log") {   # iostat.day.hour.log

   # read to get devices, content from monitor
      open (PF, "</var/web-gui/_log/monitor/iostat.$in{'prop2'}.$in{'prop'}.log");
                   flock(PF, LOCK_EX);
                   @l = <PF>;
      close (PF);
} else {
     print "no data found!"; &log_end; exit;
}

 # form
 &ask("begin");
      print "<table><tr><td>";

      print '<b>Day:</b>&nbsp;&nbsp;';
      print '<select name="prop2" class="input" onChange="this.form.submit()">';  # hour
      foreach my $d (@d) {
          if ($in{'prop2'} eq "$d") {
                 print "<option selected>$d</option>\n";
          } else {
                 print "<option>$d</option>\n";
          }
      }
      print "</select></td>\n";

      print "<td>&nbsp;&nbsp;<b>Hour:</b>";
      print '<select name="prop" class="input" onChange="this.form.submit()">';  # hour
      foreach my $h (@h) {
          if ($in{'prop'} eq "$h") {
                 print "<option selected>$h</option>\n";
          } else {
                 print "<option>$h</option>\n";
          }
      }
      print "</select></td>\n";

      print "<td>&nbsp;&nbsp;<b>Device:</b>&nbsp;";
      print '<select name="list" class="input" onChange="this.form.submit()">';
      $x=",";

      #first pools, then disks
      my @pools=();
      my @disks=();
      @w=();
      @l=sort(@l);
      $r="";
      foreach my $l (@l) {
         if ($l=~/^c\d/) {
            push(@disks,$l);
         } else {
            # rpool last
            if ($l =~/^rpool;/) {
               $r="rpool";
            } else {
               push(@pools,$l);
            }
         }
      }

      @l=();
      if ($r eq "rpool") { push (@pools,"rpool"); }

      push (@l,@pools);
      push (@l,@disks);

      foreach my $l (@l) {
            if ($l=~/^\d+\./) { next; }  # time
            if ($l=~/^cpu/)   { next; }  # cpu

            $l=~s/;.*//;
            chomp($l);

            if ($x=~/,$l,/)   { next; }

            if ($in{'list'} eq "$l") {
                 print "<option selected>$l</option>\n";
            } else {
                 print "<option>$l</option>\n";
            }
            $x.="$l,";
      }
      print "</select></td><td>&nbsp;&nbsp;<div style='position: relative; top:-18px; left:10px'>\n";

 &ask("submit");
 print "</div></td></tr></table>";

 if ($reload eq "1") {
   $in{'list'}=$l[2];          # first device after cpu = pool

   #&print_array(@l);
   #&print_hash(%in);

   &reload;                    # reload on first call with data
 }

 #&print_array(@pools);

 # header
 print "<script language='javascript'>document.getElementById('hl').innerHTML='Realtime monitor (iostat per hour, requires a PRO monitor/complete license)'</script>\n";


 ##############  stat ###################

  # data  typically 6 graphs
     # busy cpu graph1 = title; ytext; y-maxunit; data (60,commalist);          # 4 values 0-3
     # w%       graph2.= title; ytext; y-maxunit; data (60,commalist);          # 4 values 4-7
     # b%       graph3                                                          # 4 values 8-11
     # read io  graph4                                                          # 4 values 12-15
     # write io graph5                                                          # 4 values 16-19
     # wait io  graph6                                                          # 4 values 20-23

   print <<EoF;

  <script src="/_doc/rgraph/RGraph.drawing.background.js"></script>
  <script src="/_doc/rgraph/RGraph.line.js" ></script>

  <div style='width:1000px'>
    <div id='wsdata' style='position:absolute; top: 155px; left:5px; z-index:1100; color:#666666; font-size:10px; width:1000px'>
      connect to server...
    </div>
    <div style='position:absolute; left: 865px; top:290px'>
       <b style='color:blue'>busy %</b><br><br>
       <b style='color:red'>wait %</b><br><br>
       <b style='color:orange'>cpu %</b>
    </div>
    <div style='position:absolute; left: 865px; top:470px'>
       <b style='color:green'>read iops</b>
    </div>
    <div style='position:absolute; left: 865px; top:650px'>
       <b style='color:#9a53bf'>write iops</b>
    </div>
    <div style='position:absolute; left: 865px; top:830px'>
       <b style='color:black'>io waiting</b>
    </div>

    <!-- iostat last hour -->
    <br><br>
    <canvas id="cvs1" width="850" height="180">[No canvas support]</canvas>
    <canvas id="cvs2" width="850" height="180">[No canvas support]</canvas>
    <canvas id="cvs3" width="850" height="180">[No canvas support]</canvas>
    <canvas id="cvs4" width="850" height="180">[No canvas support]</canvas>


  <!-- iostat script -->
  <script type="text/javascript">

  rgraph_iostat=function(data) {

       //split data values
       var adata=data.split(";");       // busy text, wait text, cpu text, busyval, waitval, cpuval

       var RG        = RGraph;
       var canvas1   = document.getElementById("cvs1");
       var canvas2   = document.getElementById("cvs2");
       var canvas3   = document.getElementById("cvs3");
       var canvas4   = document.getElementById("cvs4");

       var busy=[];
       var wait=[];
       var cpu=[];
       var read=[];
       var write=[];
       var io=[];

       var numvalues = 60;

       // Pre-pad the arrays with null values
       for (var i=0; i<numvalues; ++i) {
             busy.push(null);
             wait.push(null);
             cpu.push(null);
             read.push(null);
             write.push(null);
             io.push(null);
       }

       //--------
       //busy data
       //adata[11]='9,2,3,4,5,6,7,8,9,1,4,6,8,3,6,8,9,3,4,9,8,9,8,7,6,5,4,8,4,2';
       busy=adata[11].split(",");                        // string values

       // add as numbers
       for (var i = 0; i < numvalues; i++ ) {
            busy[i]=parseInt(busy[i]);
       }


       //--------
       //wait data
       //adata[7]='9,2,3,4,5,6,7,8,9,1,4,6,8,3,6,8,9,3,4,9,8,9,8,7,6,5,4,8,4,2';
       wait=adata[7].split(",");                        // string values

       // add as numbers
       for (var i = 0; i < numvalues; i++ ) {
            wait[i]=parseInt(wait[i]);
       }


       //--------
       //cpu data
       //adata[3]='9,2,3,4,5,6,7,8,9,1,4,6,8,3,6,8,9,3,4,9,8,9,8,7,6,5,4,8,4,2';
       var cpu=adata[3].split(",");                        // string values

       // add as numbers
       for (var i = 0; i < numvalues; i++ ) {
            cpu[i]=parseInt(cpu[i]);
       }

       RGraph.clear(canvas1);
       RGraph.ObjectRegistry.clear(canvas1);

       new RGraph.Drawing.Background({
         id: 'cvs1',
         options: {
            gutterLeft: 55,
            gutterRight: 35,
            gutterTop: 35,
            gutterBottom: 35,
            backgroundGridAutofitNumvlines:48,
            backgroundGridAutofitNumhlines: 20,
            backgroundGridColor: '#eee'
         }
      }).draw();

      new RGraph.Line({
          id: 'cvs1',
          data: [ [100],busy,wait,cpu],                           //100 as grey=ymnin
          options: {
            linewidth: 1,
            colors: ['#cccccc','blue','red','orange'],              // ymax, busy, wait, cpu
            labels: ['','60min or day',''],
            gutterLeft: 55,
            gutterRight: 35,
            gutterBottom: 35,
            gutterTop: 35,
            textSize: '11pt',
            title: 'b% (disk is busy in % of time // w% (transactions are waiting in % of time) // cpu% (busy))',
            backgroundGridColor: '#aaa',
            backgroundGridDashed: true,
            textAccessible: true,
            scaleZerostart: true,
            labelsOffsety: 5
         }
      }).draw();

      //--------
      // read
      //adata[15]='9,2,3,4,5,6,7,8,9,1,4,6,8,3,6,8,9,3,4,9,8,9,8,7,6,5,4,8,4,2';
      read=adata[15].split(",");                        // string values

      // add as numbers
      for (var i = 0; i < numvalues; i++ ) {
            read[i]=parseInt(read[i]);
      }

      RGraph.clear(canvas2);
      RGraph.ObjectRegistry.clear(canvas2);

      new RGraph.Drawing.Background({
         id: 'cvs2',
         options: {
            gutterLeft: 55,
            gutterRight: 35,
            gutterTop: 35,
            gutterBottom: 35,
            backgroundGridAutofitNumvlines:48,
            backgroundGridAutofitNumhlines: 20,
            backgroundGridColor: '#eee'
         }
      }).draw();

      new RGraph.Line({
          id: 'cvs2',
          data: [[200],read],
          options: {
            linewidth: 1,
            colors: ['#cccccc','green'],
            labels: ['','60min or day',''],
            gutterLeft: 55,
            gutterRight: 35,
            gutterBottom: 35,
            gutterTop: 35,
            textSize: '11pt',
            title: 'read iops',
            backgroundGridColor: '#aaa',
            backgroundGridDashed: true,
            textAccessible: true,
            scaleZerostart: true,
            labelsOffsety: 5
         }
      }).draw();


      //--------
      // write
      //adata[19]='9,2,3,4,5,6,7,8,9,1,4,6,8,3,6,8,9,3,4,9,8,9,8,7,6,5,4,8,4,2';
      write=adata[19].split(",");                        // string values

      // add as numbers
      for (var i = 0; i < numvalues; i++ ) {
            write[i]=parseInt(write[i]);
      }

      RGraph.clear(canvas3);
      RGraph.ObjectRegistry.clear(canvas3);

      new RGraph.Drawing.Background({
         id: 'cvs3',
         options: {
            gutterLeft: 55,
            gutterRight: 35,
            gutterTop: 35,
            gutterBottom: 35,
            backgroundGridAutofitNumvlines:48,
            backgroundGridAutofitNumhlines: 20,
            backgroundGridColor: '#eee'
         }
      }).draw();

      new RGraph.Line({
          id: 'cvs3',
          data: [[200],write],
          options: {
            linewidth: 1,
            colors: ['#cccccc','#9a53bf'],
            labels: ['','60min or day',''],
            gutterLeft: 55,
            gutterRight: 35,
            gutterBottom: 35,
            gutterTop: 35,
            textSize: '11pt',
            title: 'write iops',
            backgroundGridColor: '#aaa',
            backgroundGridDashed: true,
            textAccessible: true,
            scaleZerostart: true,
            labelsOffsety: 5
         }
      }).draw();

     //--------
      // io
      //adata[23]='9,2,3,4,5,6,7,8,9,1,4,6,8,3,6,8,9,3,4,9,8,9,8,7,6,5,4,8,4,2';
      io=adata[23].split(",");                        // string values

      // add as numbers
      for (var i = 0; i < numvalues; i++ ) {
            io[i]=parseInt(io[i]);
      }

      RGraph.clear(canvas4);
      RGraph.ObjectRegistry.clear(canvas4);

      new RGraph.Drawing.Background({
         id: 'cvs4',
         options: {
            gutterLeft: 55,
            gutterRight: 35,
            gutterTop: 35,
            gutterBottom: 35,
            backgroundGridAutofitNumvlines:48,
            backgroundGridAutofitNumhlines: 20,
            backgroundGridColor: '#eee'
         }
      }).draw();

      new RGraph.Line({
          id: 'cvs4',
          data: [[20],io],
          options: {
            linewidth: 1,
            colors: ['#cccccc','black'], 
            labels: ['','60min or day',''],
            gutterLeft: 55,
            gutterRight: 35,
            gutterBottom: 35,
            gutterTop: 35,
            textSize: '11pt',
            title: 'io waiting',
            backgroundGridColor: '#aaa',
            backgroundGridDashed: true,
            textAccessible: true,
            scaleZerostart: true,
            labelsOffsety: 5
         }
      }).draw();
  }

  </script>
  </div>
EoF



} #/ my_action


###############################################
#end of my script, do not delete the line below
1;
