#!/usr/bin/perl
# userlib
my ($r,$opt);

#&print_hash(%in);

#part 2: actions like add&del user&groups etc
#############################################
if ($in{'action'} eq "useradd") {
#################################
    # create user (which=user)
    # account,desc,gid(g:other),uid,opt(nohome/noshell)

    $in{'account'} = lc($in{'account'}); $in{'account'}=~s/[^a-z0-9\_]//g;     # lc, max 32char

    #parse
    if ($current{'on'}=~/truenas|mswin|darwin/i)  {  &mess('create users locally on your OS');  }
    if ($user{'users'} =~/\b$in{'account'}\b/)  { &mess("account $in{'account'} already exists"); }
    $in{'desc'}=~s/ +$//; $in{'desc'}=~s/ +/_/g;

    # naming
    if (($in{'account'} =~/^\d|^\-/) || ($in{'account'} eq "") || length($in{'account'}>20)) { &mess('invalid account name or too long (max 20)'); }     # due windows max 20, debian and solaris max 32, bsd max 16

    $opt="";

    if ($current{'on'}=~/bsd/i)      {
    ##########################
        # naming
        if (($in{'account'} =~/^\d|^\-/) || ($in{'account'} eq "") || length($in{'account'}>16)) { &mess('invalid account name'); }

        #homedir
        if ($in{'opt'}=~/nohome/)  { $opt.=" -M"; }                # default="nohome noshell";
        if ($in{'opt'}=~/\bhome/)  { $opt.=" -m"; }

        #noshell
        if ($in{'opt'}=~/noshell/) { $opt.=" -s /sbin/nologin"; }

        #login group
        $in{'gid'}=~s/^g://g;
        if (!($in{'gid'}=~/=/))    { $t=$in{'gid'}; $t=~s/g://; $opt.=" -N -g $t"; }

        #uid
        $in{'uid'}=~s/\D//g;
        if ($in{'uid'}=~/\d+/)    {
           if ($in{'uid'}>=32000)                       { &mess("uid $in{'uid'} too large, use an uid < 32000"); }
           if ($user{'users_alluid'}=~/\b$in{'uid'}\b/) { &mess("uid $in{'uid'} exists, use another uid"); }
           $opt.=" -u $in{'uid'}";
        }

        #comment/desc
        # not possible in free-bsd in asduser, requires editing of /etc/passwd

        #create user
        $r=&exe("pw useradd $in{'account'}$opt");
        print "pw useradd $in{'account'}$opt <br>(no description option in Free-BSD adduser)<hr>$r<br>";

    }

    ###

    if ($current{'on'}=~/linux/i)    {
    #############################

        # special naming  ?

        # homedir
        if ($in{'opt'}=~/nohome/)  { $opt.=" -M"; }                # default="nohome noshell";
        if ($in{'opt'}=~/\bhome/)  { $opt.=" -m"; }

        #noshell
        if ($in{'opt'}=~/noshell/) { $opt.=" -s /sbin/nologin"; }

        #login group
        $in{'gid'}=~s/^g://g;
        if (!($in{'gid'}=~/=/))    { $t=$in{'gid'}; $t=~s/g://; $opt.=" -N -g $t"; }

        #uid
        $in{'uid'}=~s/\D//g;
        if ($in{'uid'}=~/\d+/)    {
           if ($in{'uid'}>=64999)                       { &mess("uid $in{'uid'} too large, use an uid < 32000"); }
           if ($user{'users_alluid'}=~/\b$in{'uid'}\b/) { &mess("uid $in{'uid'} exists, use another uid"); }
           $opt.=" -u $in{'uid'}";
        }

        #comment/desc
        if ($in{'desc'} ne "")    {
           $opt.=" -c $in{'desc'}";
        }
        $opt=~s/^ +//;

        #create user
        $r=&exe("useradd $opt $in{'account'}");
        print "useradd $opt $in{'account'}<hr>$r<br>";

    }

    ###

    if ($current{'on'}=~/solaris/i)  {
    ################# ##############

        # specialnaming ?

        #homedir
        if ($in{'opt'}=~/\bhome/)  { $opt.=" -m"; }

        #noshell
        if ($in{'opt'}=~/noshell/) { $opt.=" -s /usr/bin/false"; }

        #login group
        $in{'gid'}=~s/^g://g;
        if (!($in{'gid'}=~/=/))    { $t=$in{'gid'}; $t=~s/g://; $opt.=" -g $t"; }

        #uid
        $in{'uid'}=~s/\D//g;
        if ($in{'uid'}=~/\d+/)    {
           if ($in{'uid'}>=64999)                       { &mess("uid $in{'uid'} too large, use an uid < 32000"); }
           if ($user{'users_alluid'}=~/\b$in{'uid'}\b/) { &mess("uid $in{'uid'} exists, use another uid"); }
           $opt.=" -u $in{'uid'}";
        }

        #comment/desc
        if ($in{'desc'} ne "")    {
           $opt.=" -c $in{'desc'}";
        }
        $opt=~s/^ +//;

        #create user
        $r=&exe("useradd $opt $in{'account'}");
        print "useradd $opt $in{'account'}<hr>$r<br>";

        #$r=&exe("useradd -s /usr/bin/false $in{'account'}");
    }

    print "you can set a password locally";
    sleep(2);
    $in{'action'}="";
    &reload;
}

##################################################
# del user (preserve homedir, del homedir manually
##################################################
if (($in{'action'} =~/bin\_\w+/) && ($in{'which'} eq 'users')) {
    $t=$in{'action'};  $t=~s/bin\_//;   # keep name
    if ($t eq "root")  {  &mess('delete root is not allowed');  }

    #parse
    if ($current{'on'}=~/truenas|mswin|darwin/i)  {  &mess('delete users locally on your OS');  }

    # del user)

    if ($current{'on'}=~/linux|solaris/i) {  &exe("userdel $t"); }
    if ($current{'on'}=~/bsd/i)           {  &exe("pw userdel $t"); }

    print "userdel $t";
    $in{'action'}="";
    sleep(2);
    &reload;
}

################################
if ($in{'action'} eq "addgroup") {
################################
    $in{'account'} = lc($in{'account'}); $in{'account'}=~s/[^a-z0-9\_\-]//g;     # lc, max 32char

    #parse
    if (($in{'account'} =~/^\d/) || ($in{'account'} eq "") || length($in{'account'}>31)) { &mess('invalid account name'); }
    if ($current{'on'}=~/truenas|mswin|darwin/i)  {  &mess('create groups locally on your OS');  }
    if ($user{'groups'} =~/\b$in{'account'}\b/)   { &mess("group $in{'account'} already exists"); }

    # create smb user (no shell, no homedir uid auto)

    if ($current{'on'}=~/bsd|linux|solaris/i)     {  $r=&exe("groupadd $in{'account'}"); }

    print "create smb user $in{'account'} without pw (set locally), homedir or shell<hr>$r";
    sleep(3);
    $in{'action'}="";
    &reload;
}

# del group
##########
if (($in{'action'} =~/bin\_\w+/) && ($in{'which'} eq 'groups')) {
    $t=$in{'action'};  $t=~s/bin\_//;   # keep name
    if ($t eq "root")  {  &mess('delete root is not allowed');  }

    #parse
    if ($current{'on'}=~/truenas|mswin|darwin/i)  {  &mess('delete users locally on your OS');  }

    # del user)

    if ($current{'on'}=~/bsd|linux|solaris/i) {  $r=&exe("groupdel $t"); }

    print "delete group $t<hr>$r";
    $in{'action'}="";
    sleep(1);
    &reload;
}

###
1;